// NESColExt.h : Declaration of the CNESColExt

#ifndef __NESCOLEXT_H_
#define __NESCOLEXT_H_

/////////////////////////////////////////////////////////////////////////////
// CNESColExt

class ATL_NO_VTABLE CNESColExt :
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CNESColExt, &CLSID_NESColExt>,
    public IColumnProvider
{
public:
    CNESColExt() { }

    BEGIN_COM_MAP(CNESColExt)
        COM_INTERFACE_ENTRY_IID(IID_IColumnProvider, IColumnProvider)
    END_COM_MAP()

    DECLARE_REGISTRY_RESOURCEID(IDR_NESCOLEXT)

public:

    // IColumnProvider 
public:
    STDMETHODIMP Initialize(LPCSHCOLUMNINIT psci) { return S_OK; }
    STDMETHODIMP GetColumnInfo(DWORD dwIndex, SHCOLUMNINFO* psci);
    STDMETHODIMP GetItemData(LPCSHCOLUMNID pscid, LPCSHCOLUMNDATA pscd, VARIANT* pvarData);

    // Implementation
protected:
    bool ReadNESHeader (LPCTSTR szFilename, unsigned char *pHeader);
};

#endif //__NESCOLEXT_H_
